#ifndef __modTaskDialog__
#define __modTaskDialog__
#module mtd
#uselib "comctl32"
#func TaskDialogIndirect "TaskDialogIndirect" var,var,int,int

#define global TDF_ENABLE_HYPERLINKS			0x0001
#define global TDF_USE_HICON_MAIN				0x0002
#define global TDF_USE_HICON_FOOTER				0x0004
#define global TDF_ALLOW_DIALOG_CANCELLATION	0x0008
#define global TDF_USE_COMMAND_LINKS			0x0010
#define global TDF_USE_COMMAND_LINKS_NO_ICON	0x0020
#define global TDF_EXPAND_FOOTER_AREA			0x0040
#define global TDF_EXPANDED_BY_DEFAULT			0x0080
#define global TDF_VERIFICATION_FLAG_CHECKED	0x0100
#define global TDF_SHOW_PROGRESS_BAR			0x0200
#define global TDF_SHOW_MARQUEE_PROGRESS_BAR	0x0400
#define global TDF_CALLBACK_TIMER				0x0800
#define global TDF_POSITION_RELATIVE_TO_WINDOW	0x1000
#define global TDF_RTL_LAYOUT					0x2000
#define global TDF_NO_DEFAULT_RADIO_BUTTON		0x4000
#define global TDF_CAN_BE_MINIMIZED				0x8000

#define global TD_WARNING_ICON         0x0000FFFF // MAKEINTRESOURCEW(-1)
#define global TD_ERROR_ICON           0x0000FFFE // MAKEINTRESOURCEW(-2)
#define global TD_INFORMATION_ICON     0x0000FFFD // MAKEINTRESOURCEW(-3)
#define global TD_SHIELD_ICON          0x0000FFFC // MAKEINTRESOURCEW(-4)

#define global TDCBF_OK_BUTTON 		0x01
#define global TDCBF_YES_BUTTON		0x02
#define global TDCBF_NO_BUTTON 		0x04
#define global TDCBF_CANCEL_BUTTON 	0x08
#define global TDCBF_RETRY_BUTTON 	0x10
#define global TDCBF_CLOSE_BUTTON 	0x20

#define global IDOK 		1
#define global IDCANCEL 	2
#define global IDABORT 		3
#define global IDRETRY 		4
#define global IDIGNORE 	5
#define global IDYES 		6
#define global IDNO 		7

#define global TDN_CREATED                         0
#define global TDN_NAVIGATED                       1
#define global TDN_BUTTON_CLICKED                  2
#define global TDN_HYPERLINK_CLICKED               3
#define global TDN_TIMER                           4
#define global TDN_DESTROYED                       5
#define global TDN_RADIO_BUTTON_CLICKED            6
#define global TDN_DIALOG_CONSTRUCTED              7
#define global TDN_VERIFICATION_CLICKED            8
#define global TDN_HELP                            9
#define global TDN_EXPANDO_BUTTON_CLICKED          10

#deffunc DialogVistaInit
// ftHgp[^w (KvȂ ϐ@mtd ŏ)
	select_start = 101		// IID̊Jnԍ

	// TaskDialogIndirect Function
	pnRadioButton = 0				// __out  int *pnRadioButton
	pfVerificationFlagChecked = 0 	//  __out  BOOL *pfVerificationFlagChecked

	// TASKDIALOGCONFIG Structure
	_hwnd = hwnd			// EBhEnh
	_hinstance = hinstance	// CX^Xnh
	dwFlags = TDF_ALLOW_DIALOG_CANCELLATION | TDF_USE_COMMAND_LINKS	| TDF_ENABLE_HYPERLINKS // \tO
	dwCommonButtons = 0
	nDefaultButton = 0
	cRadioButtons = 0
	pRadioButtons = 0
	nDefaultRadioButton = 0
	pszVerificationText = 0
	pszExpandedInformation = 0
	pszExpandedControlText = 0
	pszCollapsedControlText = 0
	pfCallback = 0
	lpCallbackData = 0
	cxWidth = 0				// _CAO̕iOŎj
	
// ftHgp[^`I
return

#deffunc DialogVistaEx str _title, str _main, str _content, str _footer, str _select, int _mainico, int _footico 

	// ̊֐g邩`FbN
	if varptr(TaskDialogIndirect) = 0 : return -1	// T|[g

	// ^CgjR[hɕϊ|C^[擾
	if strlen(_title) > 0{
		sdim WTitle, strlen(_title)*2+2
		cnvstow WTitle, _title
		pWTitle = varptr(WTitle)
	}else{
		pWTitle = 0
	}
	
	// CbZ[WjR[hɕϊ|C^[擾
	if strlen(_main) > 0{
		sdim MMes, strlen(_main)*2+2
		cnvstow MMes, _main
		pMMes = varptr(MMes)
	}else{
		pMMes = 0
	}
	
	// jR[hɕϊ|C^[擾
	if strlen(_content) > 0{
		sdim SMes, strlen(_content)*2+2
		cnvstow SMes, _content
		pSMes = varptr(SMes)
	}else{
		pSMes = 0
	}
	
	// tb^[bZ[WjR[hɕϊ|C^[擾
	if strlen(_footer) > 0{
		sdim FMes, strlen(_footer)*2+2
		cnvstow FMes, _footer
		pFMes = varptr(FMes)
	}else{
		pFMes = 0
	}

	// I𕪉
	select = _select
	notesel select

	if notemax = 0 : return -2	// IȂB͐ȂB

	// ő啶񒷂擾
	maxsize = 0
	repeat notemax
		noteget tmp, cnt
		if strlen(tmp) > maxsize : maxsize = strlen(tmp)
	loop
	if maxsize = 0 : return -3	// TCYs

	// ő啶񒷂Ŕz(傫߂ɏ)
	sdim sel, maxsize*2+2, notemax

	// z jR[hɕϊȂi[
	repeat notemax
		noteget tmp, cnt
		cnvstow sel(cnt), tmp
	loop

	// TASKDIALOG_BUTTON \̂̏
	// http://msdn.microsoft.com/ja-jp/library/bb787475(en-us,VS.85).aspx
	dim dbtn, notemax*2
	st = select_start	// IIDl
	
	repeat notemax
		dbtn.(cnt*2) = st
		dbtn.(cnt*2+1) = varptr(sel(cnt))
		st++
	loop

	// CACRID̕ϊ
	switch _mainico
		case 0 : mainico = 0 : swbreak
		case 1 : mainico = TD_WARNING_ICON : swbreak
		case 2 : mainico = TD_ERROR_ICON : swbreak
		case 3 : mainico = TD_INFORMATION_ICON : swbreak
		case 4 : mainico = TD_SHIELD_ICON : swbreak
		default : mainico = _mainico : swbreak
	swend

	// tb^[ACRID̕ϊ
	switch _footico
		case 0 : footico = 0 : swbreak
		case 1 : footico = TD_WARNING_ICON : swbreak
		case 2 : footico = TD_ERROR_ICON : swbreak
		case 3 : footico = TD_INFORMATION_ICON : swbreak
		case 4 : footico = TD_SHIELD_ICON : swbreak
		default : footico = _footico : swbreak
	swend

	// TASKDIALOGCONFIG \̂̏
	// http://msdn.microsoft.com/ja-jp/library/bb787473(en-us,VS.85).aspx
	
	dim taskconf,24

	taskconf.0 = 96	// cbSize \̂̃TCYi96byteŒj
	taskconf.1 = _hwnd // hwndParent EBhEnh
	taskconf.2 = _hinstance // hInstance CX^Xnh
	taskconf.3 = dwFlags	// dwFlags \tO
	taskconf.4 = dwCommonButtons // dwCommonButtons (gȂTDCBF_OK_BUTTONn̒萔wBgȂȂ0B)
	taskconf.5 = pWTitle // pszWindowTitle@_CAÕ^Cg
	taskconf.6 = mainico // hMainIcon or pszMainIcon(p) Cɕ\ACRID̓nh
	taskconf.7 = pMMes // pszMainInstruction _CAÕCbZ[W
	taskconf.8 = pSMes // pszContent _CAOTubZ[Wij
	taskconf.9 = notemax // cButtons pӂ{^̐
	taskconf.10 = varptr(dbtn) // *pButtons TASKDIALOG_BUTTON \ ̃|C^
	taskconf.11 = nDefaultButton // nDefaultButton (gȂIDOKn̒萔wBgȂȂ0B)
	taskconf.12 = cRadioButtons // cRadioButtons ({^ł͂ȂWI{^ŁHgȂȂ0B)
	taskconf.13 = pRadioButtons // *pRadioButtons ({^ł͂ȂWI{^ŁHgȂȂ0B)
	taskconf.14 = nDefaultRadioButton // nDefaultRadioButton 	(gȂIDOKn̒萔wBgȂȂ0B)
	taskconf.15 = pszVerificationText // pszVerificationText 
	taskconf.16 = pszExpandedInformation // pszExpandedInformation
	taskconf.17 = pszExpandedControlText // pszExpandedControlText
	taskconf.18 = pszCollapsedControlText // pszCollapsedControlText
	taskconf.19 = footico // hFooterIcon or pszFooterIcon(p) tb^[ɕ\ACRID̓nh
	taskconf.20 = pFMes // pszFooter _CAÕtb^[̃bZ[W
	taskconf.21 = pfCallback // pfCallback R[obN֐n(gȂ̂0)
	taskconf.22 = lpCallbackData // lpCallbackData R[obN֐n(gȂ̂0)
	taskconf.23 = cxWidth // cxWidth _CAO̕H
	
	// s
	choose = 0
	TaskDialogIndirect taskconf, choose, pnRadioButton, pfVerificationFlagChecked
	if stat != 0 : return stat	// G[̂܂܂Ԃ

	return choose	// IIDԂ
#global
#endif
	DialogVistaInit // 